##############################################################################
# SCRIPT:  Casino v0.7                                                       #
# AUTHORS: DaRKHeaRT (darkheart@moonshine.ch rhett@lotus-net.ch)             #
#          CooPsTa (moral support/script ideas/bad humour etc)               #
#          v-man (help with how to run through dcc chat rather then msg)     #
#                                                                            #
# REQS:  * working "passchk" in your glftpd bin.                             #
#                                                                            #
# DESC : Compilation of games to lose (gamble) credits with :)               #
# INSTALL: load the script "casino.tcl" from your eggdrop.config file,       #
#          makesure casino_lib.tcl is in your scripts directory!             #
#                                                                            #
#          YOU MUST ALLOW THE LOGIN YOUR BOT IS RUNNING FROM TO BE ABLE TO   #
#          READ WRITE TO ALL USER FILES in /glftpd/ftp-data/users !          #
#          REMEMBER WHEN YOU ADD A NEW USER YOU WILL PROBABLY NEED TO        #
#          "chmod 666 /glftpd/ftp-data/users/username"   probably best way   #
#          to deal with this is crontab a script to run on the hour prehaps, #
#          which chmod 666 * in the glftpd users directory.                  #
#                                                                            #
#          if you need to compile passchk.c makesure you include lcrypt,     #
#          ie,                                                               #
#                                                                            #
#          cc passchk.c -lcrypt                                              #
#                                                                            #
#          since passchk uses the function chroot it needs to be chmod'ed    #
#          to run as root at all times, if your glftpd password file is not  #
#          located in /glftpd/etc then you will need to edit the c file and  #
#          change where it has /glftpd to the appropriate path for your copy #
#          of glftpd. if you find that even if you run passchk from the      #
#          console it says passwords are invalid when they are actually      #
#          valid that you either have your path set wrong in the .c file     #
#          or the file is not set to run as root.                            #
#                                                                            #
#          chmod u+s passchk     <-- to make file run as root                #
#                                                                            #
#          if you .restart the bot while users are connected you may find    #
#          they are still connected to casino but nothing really works, they #
#          simply need to relogin.                                           #
#                                                                            #
# CHANGELOG:                                                                 #
#    v0.1 (30/11/00) - script began, no games yet just all the authorization #
#                      stuff.                                                #
#    v0.2 (30/11/00) - added the user gets logged out after x minutes        #
#                      of inactivity                                         #
#    v0.3 (30/11/00) - made it run independently of sitebot-glftpd.tcl       #
#    v0.4 (01/12/00) - started the first game! roulette! w00t                #
#                    - added random lines from the dealer and the choice     #
#                      of other dealer personality's :p                      #
#    v0.5 (02/12/00) - made the bot edit userfile through shell rather then  #
#                      ftp to make credit updates.                           #
#                    - added "hank" (dealer personality by coop lol)         #
#    v0.6 (06/12/00) - added blackjack                                       #
#                    - converted bot to run through dcc chat rather then     #
#                      private messages                                      #
#                    - added !login to kill anything logged in under a       #
#                      username already (like !login on glftpd)              #
#                    - bot respects .lock files, not writing to user file    #
#                      if one exists and creating one when making changes.   #
#                    - added alltime winners/losers                          #
#                    - added error catches to avoid casino dropping on a bug #
#    v0.7 (10/12/00) - added .echo on|off feature    (off by default)        #
#                    - added more info to .alltime                           #
#                    - first public release!                                 #
#                                                                            #
#                                                                            #
# TODO:                                                                      #
#                                                                            #
#  add userlist                                                              #
#  make blackjack won/lost totals not update until bet is over.              #
#  add split, push to blackjack                                              #
#  add bet types split, corner, line to roulette                             #
#  add game slots (make one win option to change others tagline?)            #
#  add game poker (vs other user)                                            #
#                                                                            #
##############################################################################

# start config

#port casino listens on.
set casino(serverPort) 22221
#ip casino listens on.. [myip] will use the variable set my-ip "x.x.x.x" which is defined in your eggdrop.conf
set casino(ip) [myip]

#path to glftpd users directory.
set glusers /glftpd/ftp-data/users
#path to glftpd bin directory (location of passchk).
set glbindir /glftpd/bin

#in a glftpd user file there is a line like
#                  v---------------------------first stat section
#       CREDITS 540015 3244324 4324322
# second stat section------^     ^----------------third stat section
#
# anyway i think you get the point? now its important if you have more then one
# section where credits are seperate that you set the variable casino(order) to
# be the order in which they appear in a userfile.
#

set casino(order) "iso 0day mp3"
set casino(defaultsection) 0day

#valid dealers are: hank wally and silentbob
set casino(defaultdealer) wally

#add as many sections as needed. if you specify one here makesure you include it in casino(order)
set casinosection(0day) /notimportant
set casinosection(iso) /notimportant
set casinosection(mp3) /notimportant

#effects how many winners/losers to show in .alltime
set casino(aluplines) 10
set casino(aldnlines) 10

#max/min per single bet (in mb).
set casino(maxbet) 100
set casino(minbet) 0

#at how many minutes will idle users be booted...
set casino(timer) 30

#roulette payout rates...
set roulette(winnings,straight) "35"
set roulette(winnings,split) "17"
set roulette(winnings,street) "11"
set roulette(winnings,corner) "8"
set roulette(winnings,five) "7"
set roulette(winnings,line) "6"
set roulette(winnings,column) "2"
set roulette(winnings,dozen) "2"
set roulette(winnings,eachway) "1"

#blackjack payout rates (1 times = money back.)
set bj(winnings,blackjack) "2.5"
set bj(winnings,5cardtrick) "2"
set bj(winnings,winner) "2"
set bj(winnings,nowinner) "1"

### do not edit below this line. you have been warned.


set fields "loggedin lastonfrom defaultsection dealer all_won all_lost echo"
set casino(dealers) "wally hank silentbob"
set casino(ver) "Casino v0.7"
set casino(newuser) 0

proc casino:main {} {
  uplevel #0 {
    catch {sitebot:addversion "$casino(ver)"} versionadd
    if {[file exists scripts/casino_lib.tcl]} { source scripts/casino_lib.tcl } { uplevel #0 {die} }
    casino:checkscripts
    casino:killoldtimers
    timer 1 casino:set_idle
    casino:loaddb
    casino:cleandb
    casino:savedb
    listen $casino(serverPort) script casino:NewSession
    putlog "Casino!]: $casino(ver) by DaRKHeaRT loaded!"
  }
}

proc casino:casino:dcc { idx nick uhost username arg } { global casinoauth casinosection casino x glusers usr
        if ![info exists casinoauth($idx)] { putdcc $idx "casino!error\]: your session details are lost. (bot rehashed?) please relogin." }
        set args($username) "$arg"
        set cmd [lindex $args($username) 0]

        switch -exact -- $cmd {
          "echo" {
                if {[llength $args($username)] != 2} {
                  putdcc $idx "Echo is currently set to \"$x($username,echo)\""
                } {
                  if {([lindex $args($username) 1] != "on") && ([lindex $args($username) 1] != "off")} {
                    putdcc $idx "valid choices are on or off"
                  } {
                    set x($username,echo) [lindex $args($username) 1]
                    putdcc $idx "echo is now [lindex $args($username) 1]"
                    casino:savedb
                  }
                }
          }
          "alltime" { casino:alltime $idx }
          "statline" { putdcc $idx "[casino:statline $username]" }
          "mystats" { casino:stats $idx $username }
          "stats" {
            set usrname [lindex $args($username) 1]
            if {$usrname == ""} {putdcc $idx "Usage: .stats <username>" ; return}
            if [file exists $glusers/$usrname] {
              if [info exists usr($usrname)] {
                casino:stats $idx $usrname
              } {
                putdcc $idx "casino!error\]: that user hasnt used the casino."
              }
            } {
              putdcc $idx "casino!error\]: no such user on site"
            }
          }
          "who" {
                putdcc $idx ".. \[ who \] ..........................................."
                putdcc $idx ".     username |   online |    idle | won    lost    ."
                putdcc $idx "......................................................"
                set counter 0
                foreach id [array names casinoauth] {
                  set u [casino:match $id]
                  incr counter
                  putdcc $idx ". [format %12s $u] | [format %8s "$x($u,online) mins"] | [format %7s "[expr $casino(timer) - $x($u,idle)] mins"] | [format %-6s "[lindex [split [round $x($u,won) 1] "."] 0]MB"] [format %-7s "[lindex [split [round $x($u,lost) 1] "."] 0]MB"] ."
                }
                putdcc $idx ".......................................\[[b]$counter[b]\]............"
          }
          "gamblein" {
                if {[llength $args($username)] < 2 || [llength $args($username)] > 2} {
                  putdcc $idx "Your default gambling section is currently set to: $x($username,defaultsection)"
                } {
                  if {[lsearch -exact "[array names casinosection]" "[lindex $args($username) 1]"] != -1} {
                    set x($username,defaultsection) [lindex $args($username) 1]
                    putdcc $idx "Your default gambling section is now set to: $x($username,defaultsection)"
                    casino:savedb
                  } {
                    putdcc $idx "valid sections are: [array names casinosection]"
                  }
                }
          }
          "changedealer" {
                if {[llength $args($username)] < 2 || [llength $args($username)] > 2} {
                  putdcc $idx "Your dealer is currently: $x($username,dealer)"
                } {
                  if {[lsearch -exact $casino(dealers) "[lindex $args($username) 1]"] != -1} {
                    set x($username,dealer) "[lindex $args($username) 1]"
                    putdcc $idx "Your dealer is now: $x($username,dealer)"
                    casino:savedb
                  } {
                    putdcc $idx "the current dealers in the house are: $casino(dealers)"
                  }
                }
          }
          "ver" { putdcc $idx "$casino(ver) by DaRKHeaRT (darkheart@moonshine.ch)" }
          "help" {
                putdcc $idx ",_______________________________________________________________________"
                putdcc $idx "| $casino(ver) by DaRKHeaRT help"
                putdcc $idx "|_______________________________________________________________________"
                putdcc $idx "| .roulette                 - roulette help screen"
                putdcc $idx "| .bj                       - blackjack help screen"
                putdcc $idx "|_______________________________________________________________________"
                putdcc $idx "| .alltime                  - top $casino(aldnlines) losers and top $casino(aluplines) winners"
                putdcc $idx "| .mystats                  - your stats"
                putdcc $idx "| .stats <username>         - show someones stats"
                putdcc $idx "| .statline                 - your current session stats"
                putdcc $idx "| .who                      - whos at the casino?"
                putdcc $idx "| .gamblein <section>       - your gambling with credits from what section?"
                putdcc $idx "| .echo <on|off>            - echo what you say to yourself."
                putdcc $idx "| .ver                      - show version"
                putdcc $idx "| .changedealer <dealer>    - change dealer personality"
                putdcc $idx "| .quit                     - quit from the casino"
                putdcc $idx "|_______________________________________________________________________"
                putdcc $idx "| sections: [array names casinosection]"
                putdcc $idx "| dealers: $casino(dealers)"
                putdcc $idx "|_______________________________________________________________________"
          }
          default { putdcc $idx "casino!\]: not a valid option.. try \"help\" for commands." }
        }
}

#!login
bind msg  - !login              casino:auth_msg

proc casino:auth_msg { nick uhost hand arg } { global casinoauth x usr casino
        set username [lindex $arg 0] ; set pass [lindex $arg 1]
        if {[llength $arg] != 2} {putmsg $nick "usage: !login username password" ; return}
        if {[string index $username 0] == "!"} {
          set username [string range $username 1 end];
          set test [casino:matchuser $username]
          if {$test != "nomatch"} {unset casinoauth($test)}
        }
        if {![info exists casino(newuser)]} {set casino(newuser) 0}
        if {$casino(newuser) == 1} {putmsg $nick "casino!login\]: login function in use... please try again in a minute." ; return }
        if ![checkpass $username $pass] { putlog "casino!login\]: bad casino login attempt by $nick!$uhost ($username)" ; return }
        set found 0; foreach chan [channels] { if [onchan $nick $chan] { incr found } }
        if { $found == 0 } { putmsg $nick "casino!login\]: not authorised. (not on channel)" ; return }
        set status [casino:matchidx $nick $uhost $username]
        if {$status == 1} {putmsg $nick "casino!login\]: Your already logged in!" ; return }
        if {$status == 2} {putmsg $nick "casino!login\]: Your already logged in under someone elses username!" ; return }
        if {$status == 3} {putmsg $nick "casino!login\]: Your account is in use by someone else currently!" ; return }
        if {$status == 4} {putmsg $nick "casino!login\]: Your logged in using a differnt nickname already!" ; return }
        if {$status == 5} {putmsg $nick "casino!login\]: Your logged in using a different hostname already" ; return }
        if [checkpass $username $pass] {
          set x($username,online) 0
          set x($username,won) 0
          set x($username,lost) 0
          set x($username,firsttime) 0
          if {![info exists usr($username)]} {
            set usr($username) ""
            set x($username,firsttime) 1
            set x($username,loggedin) 0
            set x($username,lastonfrom) "first time at the casino!"
            set x($username,defaultsection) "$casino(defaultsection)"
            set x($username,dealer) "$casino(defaultdealer)"
            set x($username,all_won) 0
            set x($username,all_lost) 0
            set x($username,echo) on
          }
          incr x($username,loggedin)

          putmsg $nick "casino!login\]: $username authorized"
          putmsg $nick "casino!login\]: attempting to open dcc chat!"
          set casino(newuser) 1 ; set casino(newuser_info) "$nick $uhost $username"
          putserv "PRIVMSG $nick :DCC CHAT chat $casino(ip) $casino(serverPort)"
          putlog "casino!login\]: $username requested a session at the casino!"
          timer 1 {set casino(newuser) 0}
        }
}

#!blackjack
proc casino:blackjack:dcc { idx nick uhost username arg } { global casinoauth casinosection casino x bj cards amount
        if ![info exists casinoauth($idx)] { putdcc $idx "casino!error\]: your session details are lost. (bot rehashed?) please relogin." }
        if ![info exists bj($username,ingame)] { set bj($username,ingame) 0 }
        if {[info exists bj($username,deck)]} {if {[llength $bj($username,deck)] < 25} {putdcc $idx "casino\]: reshuffling deck" ; set bj($username,deck) $cards(deck)}}
        set args($username) "$arg"
        set cmd($username) [lindex $args($username) 0]
        switch -exact -- $cmd($username) {
                "bet" {
                  if {[llength $args($username)] != 2 } {putdcc $idx "Usage: !bj bet <amount>" ; return }
                  if {$bj($username,ingame) == 1} {putdcc $idx "You already have an active bet down.." ; return }
                  set amount($username) [lindex $args($username) 1]
                  if {![casino:testbetsize $amount($username)]} {
                    putdcc $idx "Your bet must be between $casino(minbet)MB and $casino(maxbet)MB (0=playing for fun)"
                  } {
                    if {![casino:creditcheck $username $amount($username)]} {
                      putdcc $idx "You dont have enough credits in $x($username,defaultsection) to place this bet"
                    } {
                      putdcc $idx "[casino:changecredit $username "-$amount($username)"]"
                      set bj($username,ingame) 1
                      set bj($username,cards) ""
                      set bj($username,bet) $amount($username)
                      if ![info exists bj($username,deck)] {set bj($username,deck) $cards(deck)}
                      set casino($username,runningtotal) "[casino:runningtotal $username $amount($username)]"
                      putdcc $idx "You drew a [casino:blackjack:randomcard $username]"
                      set bj($username,status) [casino:blackjack:checktotal $username]
                      casino:blackjack:dcc $idx $nick $uhost $username "hit"
#                     putdcc $idx "_________________"
#                      putdcc $idx "[u]| .bj <hit|sit> |[u]"
                    }
                  }
                }

                "hit" {
                  if {$bj($username,ingame) != 1} { putdcc $idx "[casino:dealer $x($username,dealer) "bj_nobet"]" ; return }

                  putdcc $idx "You drew a [casino:blackjack:randomcard $username]"
                  putdcc $idx "Your current cards are: $bj($username,cards)"
                  set bj($username,status) [casino:blackjack:checktotal $username]

                  if {$bj($username,status) == 0} {
                    putdcc $idx "Your current total: $bj($username,total)"
                      putdcc $idx "_________________"
                      putdcc $idx "[u]| .bj <hit|sit> |[u]"
                  }
                  if {$bj($username,status) == 1} { putdcc $idx "BlackJack!" ; casino:blackjack:dealerplay $username $idx ; set bj($username,ingame) 0}
                  if {$bj($username,status) == 2} { putdcc $idx "Your current total: $bj($username,total)  (5 card trick)"
                      putdcc $idx "_________________"
                      putdcc $idx "[u]| .bj <hit|sit> |[u]"
                  }

                  if {$bj($username,status) == 3} { putdcc $idx "You got 21.. sit! down boy!" ; casino:blackjack:dealerplay $username $idx ; set bj($username,ingame) 0}
                  if {$bj($username,status) == 4} { putdcc $idx "You Busted!" ; casino:blackjack:dealerplay $username $idx ; set bj($username,ingame) 0}
                  if {$bj($username,status) == 5} {
                      putdcc $idx "Your current total: $bj($username,total)"
                      putdcc $idx "______________________"
                      putdcc $idx "[u]| .bj <hit|sit|split> |[u]"
                      set bj($username,spliton) 1
                  }

                }
                "split" {
                  putdcc $idx "sorry splitting is not available in this version." ; return

                  if {$bj($username,ingame) != 1} { putdcc $idx "[casino:dealer $x($username,dealer) "bj_nobet"]" ; return }
                  if {$bj($username,spliton) != 1} { putdcc $idx "This is not a valid hand to split on" ; return }
                  if {![casino:creditcheck $username $amount($username)]} {
                    putdcc $idx "You dont have enough credits in $x($username,defaultsection) to split your bet"
                  } {
                    putdcc $idx "Splitting cards: [lindex $bj($username,cards) 0] and [lindex $bj($username,cards) 1]"
                    putdcc $idx "Doubling bet: [casino:changecredit $username "-$amount($username)"]"
                    putdcc $idx "Playing first hand,"
                  }
                }
                "sit" {
                  if {$bj($username,ingame) != 1} { putdcc $idx "[casino:dealer $x($username,dealer) "bj_nobet"]" ; return }
                  putdcc $idx "Sitting on \"$bj($username,total)\""
                  casino:blackjack:dealerplay $username $idx
                  set bj($username,ingame) 0
                }

                "rules" {
                  putdcc $idx "Black jack is a game where you play against the dealer, the highest score wins"
                  putdcc $idx "although if you get over 21 then you \"bust\" which means you lose, unless the"
                  putdcc $idx "dealer also busts."
                  putdcc $idx ""
                  putdcc $idx "Special Situations"
                  putdcc $idx " BlackJack    = you get an ace and a jack, pay out is one and a half times"
                  putdcc $idx " 5 card trick = your score is made up of 5 or more cards, generally wins unless dealer has blackjack/5card trick"
                  putdcc $idx ""
                  putdcc $idx "Card Values"
                  putdcc $idx " Ace   = 1 or 11"
                  putdcc $idx " King  = 10"
                  putdcc $idx " Queen = 10"
                  putdcc $idx " Jack  = 10"
                  putdcc $idx " The rest of the cards, the value on face will be used."
                  putdcc $idx ""
                  putdcc $idx "How the dealer plays"
                  putdcc $idx " If you get same score as dealer, dealer wins."
                  putdcc $idx " Dealer will sit on: $bj(sitat)"
                }

                default {
                  putdcc $idx "_____. Welcome to the blackjack tables .____"
                  putdcc $idx "| .bj"
                  putdcc $idx "| .bj rules"
                  putdcc $idx "| .bj bet <amount>"
                  putdcc $idx "| .bj hit"
                  putdcc $idx "[u]| .bj sit             [u]"
                }

        }
}

#!roulette
proc casino:roulette:dcc { idx nick uhost username arg } { global casinoauth casinosection casino x roulette

        if ![info exists casinoauth($idx)] { putdcc $idx "casino!error\]: your session details are lost. (bot rehashed?) please relogin." }
        if ![info exists roulette($username,betcounter)] {set roulette($username,betcounter) 0}
        set args($username) "$arg"
        set cmd($username) [lindex $args($username) 0]
        switch -exact -- $cmd($username) {
                "spin"  {
                        if ![info exists roulette($username,beton)] {putdcc $idx "[casino:dealer $x($username,dealer) "nobet"]" ; return}
                        putdcc $idx "[casino:dealer $x($username,dealer) "dealing"]"
                        set roulette($username,num) [rand 38] ; if {$roulette($username,num) == 37} {set roulette($username,num) "00"}
                        putdcc $idx "dealer spun up a [casino:roulette:c $roulette($username,num)]"
                        putdcc $idx "___________________________________________________________"
                        putdcc $idx "[u]bet |  bet type |  odds |  amount | status                 [u]"
                        set roulette($username,total) 0
                        for {set y($username) 0} {$y($username) < $roulette($username,betcounter)} {incr y($username)} {
                            set betno($username) [expr $y($username) + 1]
                            set odds($username) [lindex $roulette($username,bet$betno($username)) 0]
                            set amount($username) [lindex $roulette($username,bet$betno($username)) 1]
                            set bettype($username) [lindex $roulette($username,bet$betno($username)) 2]
                            set numbers($username) [lrange $roulette($username,bet$betno($username)) 3 end]
                            if {[lsearch -exact $numbers($username) $roulette($username,num)] != -1} {
                              set roulette($username,creditgain) [expr $odds($username) * $amount($username)]
                              set roulette($username,total) [expr $roulette($username,total) + $roulette($username,creditgain)]
                              set roulette($username,status) "WINNER (gain: [b]$roulette($username,creditgain)[b]MB)"
                            } {
                              set roulette($username,status) "LOSER  (loss: [b]$amount($username)[b]MB)"
                              set roulette($username,total) [expr $roulette($username,total) - $amount($username)]
                            }
                            putdcc $idx "[format %3s $betno($username)] | [format %9s $bettype($username)] | [format %5s "$odds($username):1"] | [format %7s "$amount($username)MB"] | $roulette($username,status)"
                        }
                        if {$roulette($username,betcounter) > 1} {
                          if {$roulette($username,total) > 0} {
                            putdcc $idx "----------------------------------[u]| TOTAL  (gain: [b]$roulette($username,total)[b]MB)  [u]"
                            putdcc $idx "[casino:dealer $x($username,dealer) "winner"]"
                          } elseif {$roulette($username,total) == 0} {
                            putdcc $idx "----------------------------------[u]| TOTAL  (no change)  [u]"
                            putdcc $idx "[casino:dealer $x($username,dealer) "nochange"]"
                          } else {
                            putdcc $idx "----------------------------------[u]| TOTAL  (loss: [b]$roulette($username,total)[b]MB)  [u]"
                            putdcc $idx "[casino:dealer $x($username,dealer) "loser"]"
                          }
                        } else {
                          putdcc $idx "----------------------------------------------------------"
                        }
                        putlog "casino!credit update]: $username : $roulette($username,total)MB"
                        putdcc $idx "[casino:changecredit $username $roulette($username,total)]"
                        unset roulette($username,beton)
                        unset roulette($username,betcounter)
                        unset casino($username,runningtotal)
                        putdcc $idx "[casino:dealer $x($username,dealer) "cleartable"]"
                }
                "rules" {
                        putdcc $idx "TYPES OF BETS:"
                        putdcc $idx "Straight Up: Place your chips directly on any single number (including zero and double-zero.)"
                        putdcc $idx "Split Bet: Place your chips on the line between any two numbers. "
                        putdcc $idx "Street Bet: Place your chips at the end of any row of numbers. A street bet covers three numbers "
                        putdcc $idx "Corner Bet: Place your chips at the corner where four numbers meet. All four numbers are covered. "
                        putdcc $idx "Five Bet: This bet can be made in only one place and covers five number: zero, double zero, one, two and three. "
                        putdcc $idx "Line Bet: Place your chips at the end of two rows at the intersection between them. A line bet covers all the numbers in either row, for a total of six. "
                        putdcc $idx "Column Bet: Placing a chip in one of the boxes marked \"2 to 1\" at the end of the columns covers all the numbers in that column, a total of twelve. (Neither the zero nor the double zero are covered by any of the columns.) "
                        putdcc $idx "Dozen Bet: Placing a chip in one of the three boxes marked \"1st 12,\" \"2nd 12,\" or \"3rd 12\" covers those twelve numbers. "
                        putdcc $idx "Each Way : Red/Black Even/Odd Low(1-18)/High(19-36)"
                        putdcc $idx ""
                        putdcc $idx "PAYOUT RATES (closly linked to the odds of that number turning up):"
                        putdcc $idx "straight     - (one number)     - $roulette(winnings,straight)-1"
                        putdcc $idx "split        - (two numbers)    - $roulette(winnings,split)-1"
                        putdcc $idx "street       - (three numbers)  - $roulette(winnings,street)-1"
                        putdcc $idx "corner       - (four numbers)   - $roulette(winnings,corner)-1"
                        putdcc $idx "five         - (five numbers)   - $roulette(winnings,five)-1"
                        putdcc $idx "line         - (six numbers)    - $roulette(winnings,line)-1"
                        putdcc $idx "dozens       - (twelve numbers) - $roulette(winnings,column)-1"
                        putdcc $idx "column       - (twelve numbers) - $roulette(winnings,dozen)-1"
                        putdcc $idx "eachway      - (odd or even)    - $roulette(winnings,eachway)-1"
                        putdcc $idx "             - (red or black)   - $roulette(winnings,eachway)-1"
                        putdcc $idx "             - (low or high)    - $roulette(winnings,eachway)-1"
                }
                "clearbets" {
                        if {![info exists roulette($username,beton)]} {
                          putdcc $idx "no bets down on the roulette table already wally!"
                        } {
                          unset roulette($username,beton)
                          unset roulette($username,betcounter)
                          putdcc $idx "are you sure you dont want me to spin first? wussy <g>... cleared your bets..."
                        }
                }
                "bet" {
                        if {[lindex $args($username) 1] == ""} {putdcc $idx "Usage: !roulette bet <bettype> <amount> <number/s>"}
                        set bettype($username) [lindex $args($username) 1]
                        switch -exact -- $bettype($username) {
                                "split" { putdcc $idx "this form of bet is not yet available"}
                                "corner" { putdcc $idx "this form of bet is not yet available"}
                                "line" {putdcc $idx "this form of bet is not yet available"}
                                "straight" {
                                  if {[llength $args($username)] != 4 } {putdcc $idx "Usage: !roulette bet straight <amount> <number>" }
                                  set amount($username) [lindex $args($username) 2]
                                  set number($username) [lindex $args($username) 3]
                                  if {![casino:testbetsize $amount($username)]} {
                                    putdcc $idx "Your bet must be between $casino(minbet)MB and $casino(maxbet)MB (0=playing for fun)"
                                  } {
                                    if {![casino:creditcheck $username $amount($username)]} {
                                      putdcc $idx "You dont have enough credits in $x($username,defaultsection) to place this bet"
                                    } {
                                      if {![casino:roulette:isnumber? $number($username)]} {
                                        putdcc $idx "$number($username) isnt a valid number on the board.. sheesh talk about killing your chances of winning :)"
                                      } {
                                        incr roulette($username,betcounter)
                                        set roulette($username,bet$roulette($username,betcounter)) "$roulette(winnings,straight) $amount($username) $bettype($username) $number($username)"
                                        putdcc $idx "confirmed bet number $roulette($username,betcounter), $amount($username)MB on number $number($username) at odds 1:$roulette(winnings,straight)"
                                        set casino($username,runningtotal) "[casino:runningtotal $username $amount($username)]"
                                        set roulette($username,beton) "[casino:roulette:beton $username $number($username)]"
                                      }
                                    }
                                  }
                                }
                                "street" {
                                  if {[llength $args($username)] != 4 } {putdcc $idx "Usage: !roulette bet street <amount> <street_number>" }
                                  set amount($username) [lindex $args($username) 2]
                                  set number($username) [lindex $args($username) 3]
                                  if {![casino:testbetsize $amount($username)]} {
                                    putdcc $idx "Your bet must be between $casino(minbet)MB and $casino(maxbet)MB (0=playing for fun)"
                                  } {
                                    if {![casino:creditcheck $username $amount($username)]} {
                                      putdcc $idx "You dont have enough credits in $x($username,defaultsection) to place this bet"
                                    } {
                                      if {($number($username) < 1) || ($number($username) > 12)} {
                                        putdcc $idx "$number($username) isnt a valid street on the board.. there are 12 streets... choose a street number from 1 to 12."
                                      } {
                                        incr roulette($username,betcounter)
                                        set number($username) [split [lindex $roulette($bettype($username)) [expr $number($username) - 1]] "."]
                                        set roulette($username,bet$roulette($username,betcounter)) "$roulette(winnings,$bettype($username)) $amount($username) $bettype($username) $number($username)"
                                        putdcc $idx "confirmed bet number $roulette($username,betcounter), $amount($username)MB on \"$number($username)\" at odds 1:$roulette(winnings,$bettype($username))"
                                        set casino($username,runningtotal) "[casino:runningtotal $username $amount($username)]"
                                        set roulette($username,beton) "[casino:roulette:beton $username $number($username)]"
                                      }
                                    }
                                  }
                                }
                                "five" {
                                  if {[llength $args($username)] != 3 } {putdcc $idx "Usage: !roulette bet five <amount>"}
                                  set amount($username) [lindex $args($username) 2]
                                  if {![casino:testbetsize $amount($username)]} {
                                    putdcc $idx "Your bet must be between $casino(minbet)MB and $casino(maxbet)MB (0=playing for fun)"
                                  } {
                                    if {![casino:creditcheck $username $amount($username)]} {
                                      putdcc $idx "You dont have enough credits in $x($username,defaultsection) to place this bet"
                                    } {
                                      incr roulette($username,betcounter)
                                      set roulette($username,bet$roulette($username,betcounter)) "$roulette(winnings,$bettype($username)) $amount($username) $bettype($username) $roulette($bettype($username))"
                                      putdcc $idx "confirmed bet number $roulette($username,betcounter), $amount($username)MB on \"$roulette($bettype($username))\" at odds 1:$roulette(winnings,$bettype($username))"
                                      set casino($username,runningtotal) "[casino:runningtotal $username $amount($username)]"
                                      set roulette($username,beton) "[casino:roulette:beton $username $roulette($bettype($username))]"
                                    }
                                  }
                                }
                                "column" {
                                  if {[llength $args($username)] != 4 } {putdcc $idx "Usage: !roulette bet column <amount> <1|2|3>" }
                                  set amount($username) [lindex $args($username) 2]
                                  set number($username) [lindex $args($username) 3]
                                  if {![casino:testbetsize $amount($username)]} {
                                    putdcc $idx "Your bet must be between $casino(minbet)MB and $casino(maxbet)MB (0=playing for fun)"
                                  } {
                                    if {![casino:creditcheck $username $amount($username)]} {
                                      putdcc $idx "You dont have enough credits in $x($username,defaultsection) to place this bet"
                                    } {
                                      if {($number($username) < 1) || ($number($username) > 3)} {
                                        putdcc $idx "$number($username) isnt a valid column on the board.. there are 3 columns, checkout !roulette showtable , youll get the idea:)"
                                      } {
                                        incr roulette($username,betcounter)
                                        set number($username) [split [lindex $roulette($bettype($username)) [expr $number($username) - 1]] "."]
                                        set roulette($username,bet$roulette($username,betcounter)) "$roulette(winnings,$bettype($username)) $amount($username) $bettype($username) $number($username)"
                                        putdcc $idx "confirmed bet number $roulette($username,betcounter), $amount($username)MB on \"$number($username)\" at odds 1:$roulette(winnings,$bettype($username))"
                                        set casino($username,runningtotal) "[casino:runningtotal $username $amount($username)]"
                                        set roulette($username,beton) "[casino:roulette:beton $username $number($username)]"
                                      }
                                    }
                                  }
                                }
                                "dozen" {
                                  if {[llength $args($username)] != 4 } {putdcc $idx "Usage: !roulette bet dozen <amount> <1|2|3>" }
                                  set amount($username) [lindex $args($username) 2]
                                  set number($username) [lindex $args($username) 3]
                                  if {![casino:testbetsize $amount($username)]} {
                                    putdcc $idx "Your bet must be between $casino(minbet)MB and $casino(maxbet)MB (0=playing for fun)"
                                  } {
                                    if {![casino:creditcheck $username $amount($username)]} {
                                      putdcc $idx "You dont have enough credits in $x($username,defaultsection) to place this bet"
                                    } {
                                      if {($number($username) < 1) || ($number($username) > 3)} {
                                        putdcc $idx "$number($username) isnt a valid dozen spot on the board.. there are 3 places you can bet, 1 , 2 and 3"
                                      } {
                                        incr roulette($username,betcounter)
                                        set number($username) [split [lindex $roulette($bettype($username)) [expr $number($username) - 1]] "."]
                                        set roulette($username,bet$roulette($username,betcounter)) "$roulette(winnings,$bettype($username)) $amount($username) $bettype($username) $number($username)"
                                        putdcc $idx "confirmed bet number $roulette($username,betcounter), $amount($username)MB on \"$number($username)\" at odds 1:$roulette(winnings,$bettype($username))"
                                        set casino($username,runningtotal) "[casino:runningtotal $username $amount($username)]"
                                        set roulette($username,beton) "[casino:roulette:beton $username $number($username)]"
                                      }
                                    }
                                  }
                                }
                                "eachway" {
                                  if {[llength $args($username)] != 4 } {putdcc $idx "Usage: !roulette bet eachway <amount> <red|black|low|high|odd|even>" }
                                    set amount($username) [lindex $args($username) 2]
                                    set what($username) [lindex $args($username) 3]
                                    if {![casino:testbetsize $amount($username)]} {
                                      putdcc $idx "Your bet must be between $casino(minbet)MB and $casino(maxbet)MB (0=playing for fun)"
                                    } {
                                      if {![casino:creditcheck $username $amount($username)]} {
                                        putdcc $idx "You dont have enough credits in $x($username,defaultsection) to place this bet"
                                      } {
                                        if {[lsearch "odd even black red low high" $what($username)] != -1} {
                                          incr roulette($username,betcounter)
                                          set roulette($username,bet$roulette($username,betcounter)) "$roulette(winnings,eachway) $amount($username) $bettype($username) $roulette($what($username))"
                                          putdcc $idx "confirmed bet number $roulette($username,betcounter), $amount($username)MB on $what($username) numbers at odds 1:$roulette(winnings,eachway)"
                                          set casino($username,runningtotal) "[casino:runningtotal $username $amount($username)]"
                                          set roulette($username,beton) "[casino:roulette:beton $username $roulette($what($username))]"
                                        } {
                                          putdcc $idx "invalid eachway bet, valid bets are: odd, even, black, red, low, high"
                                        }
                                      }
                                    }
                                }
                                default { putdcc $idx "invalid bet type: valid types are: straight, split, street, corner, line, column, dozen and eachway."}
                        }
                }
                "showtable" {
                        if {![info exists roulette($username,beton)]} {set roulette($username,beton) ""}
                        putdcc $idx "____________"
                        putdcc $idx "|   [charreplace [casino:roulette:cu $username 00] "." " "] [charreplace [casino:roulette:cu $username 0] "." " "]  |"
                        set output ""
                        foreach num $roulette(numbers) {
                          set output "$output [casino:roulette:cu $username $num]"
                        }
                        foreach line [splitlines $output 3] {
                           putdcc $idx "| [charreplace $line "." " "] |"
                        }
                        putdcc $idx "`----------`"
                        if {$roulette($username,beton) == ""} { unset roulette($username,beton) }
                }
                "showbets" {
                        if {$roulette($username,betcounter) == 0} {
                          putdcc $idx "no bets down on the roulette table compodre!"
                        } {
                          putdcc $idx "________________________________________________"
                          putdcc $idx "[u]bet |   bet type |  odds |  amount |   numbers  [u]"
                          for {set y($username) 0} {$y($username) < $roulette($username,betcounter)} {incr y($username)} {
                            set betno($username) [expr $y($username) + 1]
                            set odds($username) [lindex $roulette($username,bet$betno($username)) 0]
                            set amount($username) [lindex $roulette($username,bet$betno($username)) 1]
                            set gametype($username) [lindex $roulette($username,bet$betno($username)) 2]
                            set numbers($username) [lrange $roulette($username,bet$betno($username)) 3 end]
                            putdcc $idx "[format %3s $betno($username)] | [format %10s $gametype($username)] | [format %5s "$odds($username):1"] | [format %7s "$amount($username)MB"] | $numbers($username)"
                          }
                        }
                }
                default {
                        putdcc $idx "_____. Welcome to the roulette tables .____"
                        putdcc $idx "| .roulette"
                        putdcc $idx "| .roulette spin"
                        putdcc $idx "| .roulette rules"
                        putdcc $idx "| .roulette clearbets"
                        putdcc $idx "| .roulette bet dozen <amount> <1|2|3>"
                        putdcc $idx "| .roulette bet column <amount> <1|2|3>"
                        putdcc $idx "| .roulette bet street <amount> <street number (1-12)>"
                        putdcc $idx "| .roulette bet straight <amount> <number>"
                        putdcc $idx "| .roulette bet eachway <amount> <red|black|odd|even|low|high>"
                        putdcc $idx "| .roulette bet five <amount>"
                        putdcc $idx "| .roulette showtable   (bold = red numbers and underline = numbers you have bet on)"
                        putdcc $idx "| .roulette showbets"
                        putdcc $idx "|__________________________________________"
                        #split|corner|line|
                }
        }
}

### dcc connection related stuff.
proc casino:NewSession { idx } {global casinoauth casino x
  if ![info exists casino(newuser_info)] {return}
  set casinoauth($idx) $casino(newuser_info)
  set nick [lindex $casinoauth($idx) 0]
  set uhost [lindex $casinoauth($idx) 1]
  set username [lindex $casinoauth($idx) 2]
  set casino(newuser) 0
  putlog "casino!login\]: $username just logged into the casino!"
  casino:announce $idx "casino!login]: $username just entered the casino!"

  putdcc $idx "casino!login\]: last login at: $x($username,lastonfrom)"
  putdcc $idx "Welcome to the casino!"
  casino:stats $idx $username
  if {$x($username,firsttime) == 0} {
    putdcc $idx ". .help"
    putdcc $idx "......... . ."
    casino:clearoldinfo $username
  } {
    casino:casino:dcc $idx $nick $uhost $username "help"
  }
  set x($username,lastonfrom) "[clock format [clock seconds] -format "%D - %H:%M"] by $nick!$uhost"
  casino:reset_idle $username
  casino:savedb
  control $idx casino:ProcessInput
}

proc casino:ProcessInput { idx msg } {global casinoauth x
  set nick [lindex $casinoauth($idx) 0]
  set uhost [lindex $casinoauth($idx) 1]
  set username [lindex $casinoauth($idx) 2]
  putlog "casino!$username\]: $msg"
  casino:reset_idle $username
  set args($idx) [lrange $msg 1 end]
  if {$args($idx) == ""} {set args($idx) "help"}
  set choice [lindex $msg 0]
  switch -exact -- $choice {
    ".roulette" { catch {set proc [casino:roulette:dcc $idx $nick $uhost $username $args($idx)]} errors }
    ".bj" { catch {set proc [casino:blackjack:dcc $idx $nick $uhost $username $args($idx)]} errors }
    ".echo" { catch {set proc [casino:casino:dcc $idx $nick $uhost $username [string trimleft $msg "."]]} errors }
    ".statline" { catch {set proc [casino:casino:dcc $idx $nick $uhost $username [string trimleft $msg "."]]} errors }
    ".gamblein" { catch {set proc [casino:casino:dcc $idx $nick $uhost $username [string trimleft $msg "."]]} errors }
    ".changedealer" { catch {set proc [casino:casino:dcc $idx $nick $uhost $username [string trimleft $msg "."]]} errors }
    ".mystats" { catch {set proc [casino:casino:dcc $idx $nick $uhost $username [string trimleft $msg "."]]} errors }
    ".alltime" { catch {set proc [casino:casino:dcc $idx $nick $uhost $username [string trimleft $msg "."]]} errors }
    ".stats" { catch {set proc [casino:casino:dcc $idx $nick $uhost $username [string trimleft $msg "."]]} errors }
    ".help" { catch {set proc [casino:casino:dcc $idx $nick $uhost $username [string trimleft $msg "."]]} errors }
    ".who" { catch {set proc [casino:casino:dcc $idx $nick $uhost $username [string trimleft $msg "."]]} errors }
    ".ver" { catch {set proc [casino:casino:dcc $idx $nick $uhost $username [string trimleft $msg "."]]} errors }
    ".quit" {
      catch {
        foreach line [casino:quit $username] { putdcc $idx $line }
        putdcc $idx "casino!logout\]: $username logged out."
        casino:announce $idx "casino!logout]: $username just left the casino!"
        unset casinoauth($idx)
        casino:savedb
        return 1
      } errors
    }
    "" {
      putlog "casino!logout\]: lost connection to $username."
      casino:announce $idx "casino!logout]: $username just left the casino!"
      unset casinoauth($idx)
      return 1
    }
    default {
      catch {
        foreach id [array names casinoauth] {
          if {$x($username,echo) == "off"} {
            if {$id != $idx} {
              putdcc $id "<$username> $msg"
            }
          } {
            putdcc $id "<$username> $msg"
          }
        }
      } errors
    }
  }
  if {$errors != ""} {putlog "casino!errors\]: $errors"}
  casino:reset_idle $username
  return 0
}

casino:main